import edu.cmu.paid.network.*;
import edu.cmu.paid.network.voyager.*;
import edu.cmu.paid.network.exception.*;
import java.util.Vector;
import java.lang.String;

/**
 * Temp file for testing Server and Client objects.
 *
 * Local object on client.
 *
 * @author Will Ross
 */

public class RunClient {

  public static void main(String[] args) {

    INetwork_Api napi = new CNetwork_Api();


    String server_url;
    edu.cmu.paid.database.datamodel.DataObject myRequest;
    Vector response;
    int num_objects;

    //get server's url from cmd line (full namespace name)
    if(args.length == 1) {
      server_url = args[0];
      System.out.println("Server: " + server_url);
    } else {
      server_url = "//localhost:9000/NET_SERVER";
      System.out.println("Syntax:  RunClient <server url>");
      System.out.println("Defaulting to //localhost:9000/NET_SERVER");
    }

    String[] server_list = new String[2];
    server_list[0] = new String("false server name..");
    server_list[1] = server_url;

    try {

      //start voyager
      napi.clientStartup();

     //create the DataObject used to make a request.
      myRequest = new edu.cmu.paid.database.datamodel.CarObject(  );
      myRequest.setValue("Price", "20000");


      //request data
      System.out.println("RunClient: requesting data..");
      response = napi.remoteQuery( myRequest, server_list );

      //block til transfer is complete:
      napi.waitForDone();
      System.out.println("Request complete.");

      //spit it out
      if(response != null) {
        System.out.println("Retrieved " + response.size() + " objects.");
      } else {
        System.out.println("Data retrieved null.");
      }

      //napi.disconnectMachine();
      //System.out.println("client stopped.  starting again");
      //napi.clientStartup();
      
      //make a second request
      response = napi.remoteQuery( myRequest, server_list );

      //block til transfer is complete:
      napi.waitForDone();
      System.out.println("Request complete.");

      //spit it out
      if(response != null) {
        System.out.println("Retrieved " + response.size() + " objects.");
      } else {
        System.out.println("Data retrieved null.");
      }





      //close voyager to quit.
      napi.disconnectMachine();

    } catch ( Exception e ) {
      System.err.println("* RunClient: Exception thrown: " + e.toString());
    }
  }
}
